CrystalPlayer = Fill:extend{
   fill = {255,0,0},
   height = 32,
   width = 32,
   onStartFrame = function(self)
                     if the.mouse:pressed() then
                        print('hi')
                     end

                     local dx = love.mouse.getX() - 400
                     local dy = love.mouse.getY() - 300

                     self.acceleration.x = dx * 10
                     self.acceleration.y = dy * 10

                     --print(dx, dy)

                     love.mouse.setPosition(400,300)
                  end
}

local velLimit = 600
SpacePlayer = Tile:extend{
   image = 'data/ship.png',
   maxVelocity = {x=velLimit,y=velLimit},
   minVelocity = {x=-velLimit, y=-velLimit},
   lastFired = 0,
   onStartFrame = function(self)
                     --local dx = love.mouse.getX() - self.x
                     --local dy = love.mouse.getY() - self.y
                     local dx = love.mouse.getX() - 400
                     local dy = love.mouse.getY() - 300


                     self.acceleration.x = dx * 2
                     self.acceleration.y = dy * 2

                     --TODO: acceleration limit.  It should at least be proportional (not 16:9)

                     if the.mouse:pressed() then -- assumes left button
                        if love.timer.getTime() - self.lastFired > 0.25 then
                           --print('pew')
                           b = Bullet:new{
                              x = self.x, y = self.y,
                              rotation = self.rotation,
                              velocity = {
                                 x = self.velocity.x * 1.5,
                                 y = self.velocity.y * 1.5
                              },
                           }
                           the.app.view:add(b)
                           self.lastFired = love.timer.getTime()
                        end
                     end
                  end,
   onUpdate = function(self)
                 self.rotation = math.atan2(self.velocity.y, self.velocity.x)
              end
}